力扣1049.最后一块石头的重量(01背包)之理解篇

1049. 最后一块石头的重量 II

cpp 复制代码
class Solution {
public:
    int lastStoneWeightII(vector<int>& stones) {
        int sumNum = 0;
        for(int i = 0;i < stones.size();++i){
            sumNum += stones[i];
        }
        int target = sumNum / 2;
        vector<int>dp(target + 1, 0);
        for(int i = 0;i < stones.size();++i){
            for(int j = target;j >= stones[i];--j){
                dp[j] = max(dp[j], dp[j - stones[i]] + stones[i]);
            }
        }
        return sumNum - dp[target] - dp[target];
    }
};

思考了很久不知道为什么将一堆石头划分为质量最接近的两堆,然后他们之差就是最后的结果.

后来仔细想了想还是想出来了,以下是我的理解:

可以将两堆抽象为两杯水,我们把两堆石头各化为水装进两个杯子,如果两个杯子水的总量相同,证明我们可以将所有石头全部碰碎(目前为止没有问题)

我们采取的方法是将石头划为质量最接近的两堆,因为质量最接近,如果质量相等直接返回0.如果不相等,说明我们使用的01背包方法已经为我们找到了尽可能装满sumNum/2的最优解,即能够使得碰撞后剩下的最后一个石头最小,(我的疑虑是为什么结果不是一边剩下两块石头或更多,但实际上,这种情况并不会出现,因为如果出现这种情况,说明左右总大小还不是最接近sumNum/2的最优解),最优解就是保证了左右碰撞后只能剩下最后一个石头,并且其在所有碰撞结果中最小.

这题我简化为两杯水去理解,结果就是豁然开朗,可以吧石头的碰撞简单地想象为消消乐(水与水之间的消消乐).

题外话:二刷到动态规划,还是觉得自己在动态规划这方面没有充分的理解,我觉得未来还要考虑三刷

相关推荐
NEFU_Jyj2 小时前
牛客周赛R168
算法
文丑颜不良啊10 小时前
LeetCode2221~2240题目解析
java·leetcode
Navigator_Z10 小时前
LeetCode //C - 1317. Convert Integer to the Sum of Two No-Zero Integers
c语言·算法·leetcode
D e re k ZH11 小时前
C++ 标准库算法全景指南
数据结构·c++·算法
冻柠檬飞冰走茶11 小时前
字母移动游戏题解:贪心求最长可保留连续子串(附 C 实现)
c语言·开发语言·数据结构·算法·动态规划
文丑颜不良啊12 小时前
LeetCode2161~2180题目解析
java·leetcode
雪落漂泊12 小时前
C++算法 二分查找篇(上)
开发语言·c++·算法
文丑颜不良啊13 小时前
LeetCode2141~2160题目解析
java·leetcode
LabVIEW开发14 小时前
LabVIEW 连接板:28 个端子怎么排,优先级怎么定
java·算法·labview